#ifndef _OUTPUT_H_
#define _OUTPUT_H_

#define CHAR_HEIGHT 12
#define CHAR_WIDTH 8

#define TAB_WIDTH 4
#define MAX_COL SCREEN_WIDTH/CHAR_WIDTH
#define MAX_LINE SCREEN_HEIGHT/CHAR_HEIGHT

inline void setPixelBuf(void* scrbuf, unsigned x, unsigned y, uint16_t color);

void putChar(void* scrbuf, unsigned x, unsigned y, uint8_t chr);

void putCharColor(void* scrbuf, unsigned x, unsigned y, uint8_t chr, uint16_t chrcolor, uint16_t bgcolor);

void dispString(void* scrbuf, unsigned x, unsigned y, const char* message);/*40 cols  20 lines*/

void dispStringColor(void* scrbuf, unsigned x, unsigned y, char* message, uint16_t chrcolor, uint16_t bgcolor);

void dispStringWithSelection(void* scrbuf, unsigned x, unsigned y, char* message, int selectionstart, int selectionend);

void dispTextWithSelection(void* scrbuf, char* message, int selectionstart, int selectionend);

void dispCursor(uint8_t* scrbuf, int offset, char* displinep);

void dispSelection(uint8_t* scrbuf, int startoffset, int endoffset, char* displinep);

#endif
